routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\UserController;
use App\Http\Controllers\ProjectController;
use App\Http\Controllers\TaskController;
use App\Http\Controllers\LoginController;
/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/
Route::middleware('auth')->group( function () {
Route::get('/', function () {
    return view('inicio');
})->name('inicio');

// USUARIOS
Route::resource('users',UserController::Class);
Route::get('users/activate/{id}',  [UserController::class, 'activate'])->name('users.activate');
Route::get('users/filter/{filter}/{pages}',  [UserController::class, 'filter'])->name('users.filter');
Route::post('users/ajax/getById',  [UserController::class, 'getById'])->name('users.getById');

Route::resource('projects',ProjectController::Class);
Route::get('projects/activate/{id}',  [ProjectController::class, 'activate'])->name('projects.activate');
Route::post('projects/ajax/getById',  [ProjectController::class, 'getById'])->name('projects.getById');

Route::resource('tasks',TaskController::Class);
Route::post('tasks/ajax/getById',  [TaskController::class, 'getById'])->name('tasks.getById');
Route::post('tasks/ajax/play',  [TaskController::class, 'playHours'])->name('tasks.play');
Route::post('tasks/ajax/stop',  [TaskController::class, 'stopHours'])->name('tasks.stop');
Route::post('tasks/ajax/check',  [TaskController::class, 'checkCounter'])->name('tasks.check');
Route::post('tasks/ajax/state',  [TaskController::class, 'state'])->name('tasks.state');

});


Route::get('login', [LoginController::class, 'loginForm'])->name('login');
Route::post('login/verify',[LoginController::class, 'verificar'])->name('verificar');
Route::get('/logout',[LoginController::class, 'logout'])->name('logout');

app/Models/User.php
<?php

namespace App\Models;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Notifications\Notifiable;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Auth\Authenticatable;
use Illuminate\Contracts\Auth\Authenticatable as AuthenticatableContract;

class User extends Model implements AuthenticatableContract
{ 
    use  HasFactory, Notifiable, Authenticatable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name',
        'email',
        'password',
        'role',
        'dni',
        'enterprise',
        'address',
        'active'
    ];

    public function projects()
    {
        return $this->hasMany(Project::class);
    }
    public function tasks()
    {
        return $this->hasMany(Task::class);
    }
}

app/Http/Controllers/UserController.php
<?php

namespace App\Http\Controllers;
use App\Models\User;
use App\Models\Project;
use App\Models\Task;

use Illuminate\Http\Request;

class UserController extends Controller
{   
    public function checkRole(){
        if(auth()->user()->role=='admin'){      
            return true;
        }
        else{
            return false;
        }
    }
    /**
     * Display a listing of the resource.
     *
     */
    public function index(){
        if(!$this->checkRole()){return redirect()->route('inicio');}   
        $filter='id';
        $users = User::orderBy('id', 'ASC')->paginate(5);
        return view('admin.users.index',['users'=> $users, 'filter'=>$filter,'actualpages'=>5]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        if(!$this->checkRole()){return redirect()->route('inicio');}   
        return view('admin.users.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        if(!$this->checkRole()){return redirect()->route('inicio');}
        $validated = $request->validate([
            'name' => 'required|min:2|max:255',
            'email' => 'required|unique:users|email',
            'password' => 'required|min:5|max:20',
            'role' => 'required',
        ]);
        if ($validator->fails()) {
            return back()->withErrors($validator)->withInput();
        }
        $user = new User();
        $user->name = $request->get('name');
        $user->email = $request->get('email');
        $user->password = bcrypt($request->get('password'));
        $user->role = $request->get('role');
        $user->dni = $request->get('dni');
        $user->enterprise = $request->get('enterprise');
        $user->address = $request->get('address');
        $user->save();
        return back()->with('message', 'User created successfully');    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        if(!$this->checkRole()){return redirect()->route('inicio');}   
        $user=User::findOrFail($id);
        return view('admin.users.update', compact('user'));    
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {   
        if(!$this->checkRole()){return redirect()->route('inicio');}   
        $user=User::findOrFail($id);
        $user->name = $request->get('name');
        $user->email = $request->get('email');
        if(!empty($request->get('password'))){
            $user->password = bcrypt($request->get('password'));
        }
        $user->dni = $request->get('dni');
        $user->enterprise = $request->get('enterprise');
        $user->address = $request->get('address');
        $user->save();
        return back()->with('message', 'User updated successfully');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {           
        if(!$this->checkRole()){return redirect()->route('inicio');}   
        $user=User::findOrFail($id);
        $user->active=false;
        $user->save();
        return back()->with('message', 'User disabled successfully');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function activate($id)
    {   
        if(!$this->checkRole()){return redirect()->route('inicio');}   
        $user=User::findOrFail($id);
        $user->active=true;
        $user->save();
        return back()->with('message', 'User enabled successfully');
    }

    public function filter($filter,$pages)
    {   
        if(!$this->checkRole()){return redirect()->route('inicio');}   
        $users = User::orderBy($filter, 'ASC')->paginate($pages);
        return view('admin.users.index',['users'=> $users, 'filter'=>$filter,'actualpages'=>$pages]);
    }

    public function getById(Request $request){
        $user=User::findOrFail($request->id);
        return response(json_encode($user),200)->header('Content-type','text-plain');
    }

}

resources/views/admin/users/_update.blade.php
@extends('plantilla')
@section('titulo', 'Editar User')
@section('contenido')
<div class="d-flex flex-column justify-content-center align-items-center" style="height: 80%;">
    <h1>Editar User {{$user->id}}</h1>
	<form action="{{ route('users.update', $user->id) }}" method='POST'>
        @csrf
        @method('PUT')
            <div class="form-group">
                <label for="name">name</label>
                <input type="text" name="name" class="form-control" value="{{$user->name}}">
            </div>
            <div class="form-group">
                <label for="email">email</label>
                <input type="mail" name="email" class="form-control" value="{{$user->email}}">
            </div>
            <div class="form-group">
                <label for="password">password</label>
                <input type="password" name="password" class="form-control" value="{{$user->password}}">
            </div>
            @if($user->role=='customer')            
            <div style="display:block">
            @else
            <div style="display:none">
            @endif
                <div class="form-group">
                    <label for="dni">dni</label>
                    <input type="text" name="dni" class="form-control" value="{{$user->dni}}">
                </div>
                <div class="form-group">
                    <label for="enterprise">enterprise</label>
                    <input type="text" name="enterprise" class="form-control" value="{{$user->enterprise}}">
                </div>
                <div class="form-group">
                    <label for="address">address</label>
                    <input type="text" name="address" class="form-control" value="{{$user->address}}">
                </div>
            </div>
            <div class="form-group text-center">
                <button type="submit" class="btn btn-primary" style="padding:8px 100px;margin-top:25px;">Editar User</button>
            </div>
    </form>
</div>
@endsection

resources/views/admin/users/create.blade.php
@extends('plantilla')
@section('titulo', 'Crear User')
@section('contenido')
<div class="d-flex flex-column justify-content-center align-items-center" style="height: 80%;">
    <h1>Nuevo User</h1>
	<form action="{{ route('users.store') }}" method='POST'>
        @csrf
            <div class="form-group">
                <label for="name">name</label>
                <input type="text" name="name" class="form-control">
            </div>
            <div class="form-group">
                <label for="email">email</label>
                <input type="mail" name="email" class="form-control">
            </div>
            <div class="form-group">
                <label for="password">password</label>
                <input type="password" name="password" class="form-control">
            </div>
            <label for="role">role</label>
            <select name="role" onchange="showDiv('hidden_div', this)">
                <option value="admin">admin</option>
                <option value="customer">customer</option>
                <option value="worker" selected>worker</option>
            </select>
            <div id="hidden_div" style="display:none">
                <div class="form-group">
                    <label for="dni">dni</label>
                    <input type="text" name="dni" class="form-control">
                </div>
                <div class="form-group">
                    <label for="enterprise">enterprise</label>
                    <input type="text" name="enterprise" class="form-control">
                </div>
                <div class="form-group">
                    <label for="address">address</label>
                    <input type="text" name="address" class="form-control">
                </div>
            </div>
             <div class="form-group text-center">
                <button type="submit" class="btn btn-primary" style="padding:8px 100px;margin-top:25px;">Añadir User</button>
            </div>
    </form>
</div>
<script>
function showDiv(divId, element){
    document.getElementById(divId).style.display = element.value == 'customer'  ? 'block' : 'none';
}
</script>
@endsection

resources/views/admin/users/index.blade.php
@extends('plantilla')
@section('titulo', 'Users')
@section('contenido')
        <div class="table-wrapper">
            <div class="table-title">
                <div class="row">
                    @if (\Session::has('message'))
                    <div class="col-sm-12 alert alert-success alert-dismissible fade show" role="alert" style="z-index:99">
                            <ul>
                                <li>{!! \Session::get('message') !!}</li>
                            </ul>
                            <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                                <span aria-hidden="true">&times;</span>
                            </button>
                        </div>
                    @endif 
                    @if (count($errors) > 0)
                        <div class="col-sm-12 alert alert-warning alert-dismissible fade show" role="alert" style="z-index:99">
                            <ul>
                                <li class="errors-li">@foreach ($errors->all() as $error){{ $error }} <br> @endforeach</li>
                            </ul>
                            <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                                <span aria-hidden="true">&times;</span>
                            </button>
                        </div>
                    @endif 
                    <div class="col">
                        <h2><b>Users</b></h2>
                    </div>
                    
                    <div class="col d-flex justify-content-end">
                    {{  $users->links() }}
                    </div>                  
                </div>
            </div>
            <table class="table table-responsive">
                <thead>
                    <tr>
                        <th>id</th>
                        <th>name</th>
                        <th>email</th>
                        <th>role</th>
                        <th>dni</th>
                        <th>enterprise</th>
                        <th>address</th>
                        <th>active</th>
						<th></th>
                    </tr>
                </thead>
                <tbody>
					@foreach($users as $user)
                    <tr>
                        <td>{{  $user->id }}</td>
                        <td>{{  $user->name }}</td>
                        <td>{{  $user->email }}</td>
						<td>{{  $user->role }}</td>
                        <td>{{  $user->dni }}</td>
						<td>{{  $user->enterprise }}</td>
						<td>{{  $user->address }}</td>
						<td>{{  boolean($user->active) }}</td>
                        <td class="d-flex justify-content-around">
                        <button  user-id="{{$user->id}}" class="btn editUsuario edit-button" ><i class='bx bx-pencil'></i></button>
                        @if($user->active==false)
                        <a href="{{  route('users.activate', $user) }}" class="btn able-button"><i class='bx bx-check'></i></a>
                        @endif
                        @if($user->active==true)
                        <form action="{{  route('users.destroy', $user) }}" method="POST">
							@method('DELETE')
							@csrf
							<button class="btn unable-button"><i class='bx bx-trash'></i></button>
                        </form>
                        @endif
						</td>
                    </tr>
					@endforeach
					
                </tbody>
            </table>
            <div class="col-12 d-flex justify-content-center">
            <a type="button" class="btn add-button" data-toggle="modal" href="#createUser" ><i class='bx bx-plus'></i></a>
            </div>
        </div>
        
<div class="modal fade" id="editUser" tabindex="-1" role="dialog" aria-labelledby="exampleModalCenterTitle" aria-hidden="true">
  <div class="modal-dialog modal-dialog-centered" role="document">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title" id="exampleModalCenterTitle">Edit User</h5>
        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
          <span aria-hidden="true">&times;</span>
        </button>
      </div>
      <form  action="{{ route('users.update',1) }}" method='POST'>
        @csrf
        @method('PUT')
        <div class="modal-body">
            <div class="form-group">
                <label for="name">name</label>
                <input type="text" name="name" class="form-control">
            </div>
            <div class="form-group">
                <label for="email">email</label>
                <input type="mail" name="email" class="form-control">
            </div>
            <div class="form-group">
                <label for="password">password</label>
                <input type="password" name="password" class="form-control">
            </div>
                <div class="form-group">
                    <label for="dni">dni</label>
                    <input type="text" name="dni" class="form-control">
                </div>
                <div class="form-group">
                    <label for="enterprise">enterprise</label>
                    <input type="text" name="enterprise" class="form-control">
                </div>
                <div class="form-group">
                    <label for="address">address</label>
                    <input type="text" name="address" class="form-control">
                </div>
        </div>
        <div class="modal-footer">
            <button type="button" class="btn close-button" data-dismiss="modal">Close</button>
            <button type="submit" class="btn add-button" >Edit User</button>
        </div>
    </form>
    </div>
  </div>
</div>
<!-- Add Modal -->
<div class="modal fade" id="createUser" tabindex="-1" role="dialog" aria-labelledby="exampleModalCenterTitle" aria-hidden="true">
  <div class="modal-dialog modal-dialog-centered" role="document">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title" id="exampleModalCenterTitle">Add User</h5>
        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
          <span aria-hidden="true">&times;</span>
        </button>
      </div>
      <form  action="{{ route('users.store') }}" method='POST'>
        @csrf
        <div class="modal-body">
            <div class="form-group">
                <label for="name">name</label>
                <input type="text" name="name" class="form-control"  minlength="2" maxlength="255" required>
            </div>
            <div class="form-group">
                <label for="email">email</label>
                <input type="mail" name="email" class="form-control" required>
            </div>
            <div class="form-group">
                <label for="password">password</label>
                <input type="password" name="password" class="form-control" minlength="5" maxlength="20" required>
            </div>
            <label for="role">role</label>
            <select name="role" required>
                <option value="admin">admin</option>
                <option value="customer">customer</option>
                <option value="worker" selected>worker</option>
            </select>
                <div class="form-group">
                    <label for="dni">dni</label>
                    <input type="text" name="dni" class="form-control" minlength="7">
                </div>
                <div class="form-group">
                    <label for="enterprise">enterprise</label>
                    <input type="text" name="enterprise" class="form-control" minlength="5">
                </div>
                <div class="form-group">
                    <label for="address">address</label>
                    <input type="text" name="address" class="form-control" minlength="5">
                </div>
            </div>
        <div class="modal-footer">
        <button type="button" class="btn close-button" data-dismiss="modal">Close</button>
        <button type="submit" class="btn add-button" >Add User</button>
        </div>
    </form>
    </div>
  </div>
</div>
@endsection
@section('javascript')
<script src="https://code.jquery.com/ui/1.11.3/jquery-ui.min.js"></script>

<script>
$(".editUsuario").click(function(){
    $('.modal-dialog').draggable();

    id=$(this).attr('user-id');
    $.ajax({
        url:"{{route('users.getById')}}",
        method: 'POST',
        data:{
            id:id,
            _token:$('input[name="_token"]').val()
        }
    }).done(function(res){
        var user=JSON.parse(res);
        console.log(user);
        $("#editUser").modal('show');
        $("#editUser input[name=name]").val(user.name);
        $("#editUser form").attr('action', '/users/'+ user.id);
        $("#editUser input[name=email]").val(user.email);
        $("#editUser input[name=dni]").val(user.dni);
        $("#editUser input[name=enterprise]").val(user.enterprise);
        $("#editUser input[name=address]").val(user.address);
    })
});
</script>
@endsection

resources/views/admin/users/show.blade.php
@extends('plantilla')
@section('titulo', "Fitxa de User")
@section('contenido')
<div class="d-flex flex-row justify-content-around" style="width:100%;">
	<div class=" card text-white bg-dark" style="width: 18rem;">
		<div class="card-header">Creado en {{  Carbon\Carbon::parse($user->created_at)->format('d/m/Y') }}</div>
		<div class="card-body">
			<h5 class="card-title">Id</h5>
			<p class="card-text">{{ $user->id }}</p>
			<h5 class="card-title">Name</h5>
			<p class="card-text">{{ $user->name }}</p>
			<h5 class="card-title">Email</h5>
			<p class="card-text">{{ $user->email }}</p>
			<h5 class="card-title">Rol</h5>
			<p class="card-text">{{ $user->rol }}</p>
			<a href="{{  route('users.edit', $user) }}" class="btn btn-success" style='height:max-content'>Editar</a>
                <form action="{{  route('users.destroy', $user) }}" method="POST">
					@method('DELETE')
					@csrf
					<button class="btn btn-danger">Borrar</button>
				</form>
		</div>
	</div>
	<div class="table-wrapper">
            <div class="table-title">
                <div class="row">
                    <div class="col-sm-8"><h2>Órdenes de <b>{{ $user->name }}</b></h2></div>
                    @if (\Session::has('message'))
                        <div class="col-sm-4 alert alert-success">
                            <ul>
                                <li>{!! \Session::get('message') !!}</li>
                            </ul>
                        </div>
                    @endif  
                </div>
            </div>
            <table class="table table-bordered">
                <thead>
                    <tr>
                        <th>Id</th>
                        <th>State</th>
                        <th>Address</th>
                        <th>User</th>
                        <th>Acciones</th>
                    </tr>
                </thead>
                <tbody>
					@foreach($user->orders as $order)
                    <tr>
                        <td>{{  $order->id }}</td>
                        <td>{{  Estado($order->state) }}</td>
                        <td>{{  $order->address }}</td>
						<td>{{  userName($order->user_id) }}</td>
                        <td class="d-flex justify-content-around">
							<a href="{{  route('orders.show', $order) }}" class="btn btn-outline-primary" style='height:max-content'>Ver</a>
							<a href="{{  route('orders_download', $order) }}" class="btn btn-outline-success" style='height:max-content'>Descargar</a>
						</td>
                    </tr>
					@endforeach
                </tbody>
            </table>
        </div>
</div>	
@endsection